#include <system.h>

unsigned char *memcpy(void *dest, const void* src, int count)
{
    const char *sp =(const char*)src;
    char *dp = (char *)dest;
    for(;count != 0; count --) 
        *dp++ = *sp++;
    return dest;
}

unsigned char *memset(void *dest, char val, int count)
{
    char *temp = (char *)dest;
    for(;count != 0;count--) 
        *temp++ = val;
    return dest;
}

unsigned short* memsetw(unsigned short *dest, unsigned short val, int count)
{
    unsigned short *temp = (unsigned short*) dest;
    for(;count != 0;count --) *temp++ = val;
        return dest;
}

int strlen(const char* str)
{
    int retval;
    for(retval=0;*str!='\0';str++) retval++;
    return retval;
}

unsigned char inportb(unsigned short _port)
{
    unsigned char rv;
    __asm__ __volatile__("inb %1,%0" : "=a" (rv) : "dN" (_port));
    return rv;
}

void outportb(unsigned short _port, unsigned char _data)
{
    __asm__ __volatile__("outb %1, %0" : :"dN" (_port), "a" (_data));
}

void main()
{
    init_video();
    puts("initializing the kernel...\n");
    
    gdt_install();
    puts("GDT initialized...\n");
    idt_install();
    puts("IDT initialized...\n");
    isrs_install();
    puts("ISR initialized...\n");
    irq_install();
    puts("IRQ initialized...\n");
    __asm__ __volatile__ ("sti"); 
    
    timer_install();
    puts("8253/8254 timer initialized...\n");
    
    keyboard_install();
    puts("keyboard installed ....\n");
    //timer_wait(2);        
    
    
    initialise_paging();
    puts("paging installed\n");
    //puts("\n\ntushar's Kernel $");
    
    
    //test the interrupt subroutines
//     __asm__ __volatile__ ("int $0xE"); 
    
    
    
    //cls();
    puts("\nHello, paging world !!!");
   

    u32int *ptr = (u32int*) 0xA0000000;
    u32int do_page_fault;
    *ptr = 99999;
    
  /*
  while(1)
    {
    do_page_fault =(u32int) *ptr;
    ptr += 0x100000;
    putch('\n');
    puthex(ptr);
    }

    */
    
    for(;;);
   
    //{
        if(bufferFlag == 1)     /* some command line string has been entered */ 
        {                           
            puts(keyboardBuffer);
            puts("\ntushar's Kernel $");
            bufferFlag = 0; /* clear the buffer flag */
        }
    //}

    
}

