# include<system.h>

void timer_phase(int hz)
{
    int divisor = 1193180/hz;
    outportb(0x43, 0x36);
    outportb(0x40, divisor & 0xFF);
    outportb(0x40, divisor >> 8);
}

/* This will keep track of how many ticks that the system 
* has been running for */
int timer_ticks = 18;
int seconds = 0;

/* Handles the time. In this case, its very simple: we
* increment the 'timer_ticks' variable every time the timer
* fires. By default the timer fires 18.222 times
* per second. */
void timer_handler(struct regs *r)
{
    
    timer_ticks ++;
    if(timer_ticks % 18 ==0)
    {
        seconds ++;
        
        //putch('0'+seconds);
        //puts(" seconds has passed \n");
    }
}

int getSeconds()
{
    return seconds;
}

void timer_wait(int ticks)      /* this function does not work unless there is a putch() in the while loop */
{
    ticks = ticks + getSeconds();
    while(getSeconds() < ticks) 
    {
                     
    }
    puts("Timer wait is over ...\n");
}

void timer_install()
{
    irq_install_handler(0, timer_handler);
}
